Summary: Tomcat 4.1 Servlet/JSP Container
Name: tomcat
Version: 4.1.30
Release: 2.rhfc1
License: Apache Software License
Vendor: LXPRO.COM
Distribution: LXPRO.COM
Group: Networking/Daemons
URL: http://jakarta.apache.org/tomcat/
Source0: rsync://jakarta.apache.org::apache-dist/jakarta/tomcat-4/v4.1.30/bin/jakarta-tomcat-4.1.30-LE-jdk14.tar.gz
Source1: rsync://jakarta.apache.org::apache-dist/jakarta/tomcat-4/v4.1.30/src/jakarta-tomcat-connectors-4.1.30-src.tar.gz
Source2: jk.conf
Source3: jk2.conf
Source4: workers.properties
Source5: workers2.properties
Source6: tomcat.init
Source7: tomcat.logrotate
Patch: deprecation-errors.patch
Buildroot: %{_tmppath}/%{name}-%{version}-root
Packager: Gregory E. Bailey <gbailey@lxpro.com>
Requires: j2sdk >= 1.4 webserver >= 2.0
BuildRequires: j2sdk = 2000:1.4.2_05-fcs httpd-devel >= 2.0.49 apr-devel apr-util-devel

%description
This subproject contains a server that conforms to the Servlet 2.3 and
JSP 1.2 specifications from Java Software.  It includes the following contents:

  BUILDING.txt                Instructions for building from sources
  LICENSE                     Apache Software License for this release
  README.txt                  This document
  RELEASE-NOTES-*.txt         Release Notes for this (and previous) releases
                              of Tomcat 4.1
  RUNNING.txt                 Instructions for installing Tomcat, as well as
                              starting and stopping the server
  bin/                        Binary executables and scripts
  common/                     Classes available to both Catalina internal
                              classes and web applications:
    classes/                  Unpacked common classes
    lib/                      Common classes in JAR files
  conf/                       Configuration files
  logs/                       Destination directory for log files
  server/                     Internal Catalina classes and their dependencies
    classes/                  Unpacked classes (internal only)
    lib/                      Classes packed in JAR files (internal only)
  shared/                     Classes shared by all web applications
    classes/                  Unpacked shared classes
    lib/                      Shared classes in JAR files
  webapps/                    Base directory containing web applications
                              included with Tomcat 4.1
  work/                       Scratch directory used by Tomcat for holding
                              temporary files and directories
  temp/                       Directory used by JVM for temporary files
                              (java.io.tmpdir)

If you wish to build the Tomcat server from a source distribution,
please consult the documentation in "BUILDING.txt".

If you wish to install and run a binary distribution of the Tomcat server,
please consult the documentation in "RUNNING.txt".

%prep
%setup -c tomcat-%{version} -T -a 0
%setup -c tomcat-%{version} -T -a 1 -D
%patch -p0

%build
pushd jakarta-tomcat-connectors-4.1.30-src/jk/native
sh buildconf.sh
./configure --with-apxs=/usr/sbin/apxs --with-java-home=/usr/java/j2sdk1.4.2_05
pushd common
make
popd
pushd apache-2.0
make
popd
popd

pushd jakarta-tomcat-connectors-4.1.30-src/jk/native2
sh buildconf.sh
./configure --with-apxs2=/usr/sbin/apxs --with-java-home=/usr/java/j2sdk1.4.2_05 \
  --with-apr-include=/usr/include/apr-0
pushd server/apache2
make
popd
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d
cp -a %{SOURCE2} $RPM_BUILD_ROOT/etc/httpd/conf.d/jk.conf-sample
cp -a %{SOURCE3} $RPM_BUILD_ROOT/etc/httpd/conf.d/jk2.conf-sample
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf
cp -a %{SOURCE4} $RPM_BUILD_ROOT/etc/httpd/conf/.
cp -a %{SOURCE5} $RPM_BUILD_ROOT/etc/httpd/conf/.
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
cp -a %{SOURCE6} $RPM_BUILD_ROOT/etc/rc.d/init.d/tomcat
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
cp -a %{SOURCE7} $RPM_BUILD_ROOT/etc/logrotate.d/tomcat
mkdir -p $RPM_BUILD_ROOT/usr/lib/httpd/modules
cp -a jakarta-tomcat-connectors-4.1.30-src/jk/native/apache-2.0/mod_jk.so \
  $RPM_BUILD_ROOT/usr/lib/httpd/modules/.
cp -a jakarta-tomcat-connectors-4.1.30-src/jk/build/jk2/apache2/mod_jk2.so \
  $RPM_BUILD_ROOT/usr/lib/httpd/modules/.
mkdir -p $RPM_BUILD_ROOT/var/tomcat
cp -a jakarta-tomcat-4.1.30-LE-jdk14/bin $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/common $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/conf $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/logs $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/server $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/shared $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/temp $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/webapps $RPM_BUILD_ROOT/var/tomcat/.
cp -a jakarta-tomcat-4.1.30-LE-jdk14/work $RPM_BUILD_ROOT/var/tomcat/.

# Now that the /var/tomcat directory hierarchy is set up,
# delete unnecessary (Windows) stuff...

rm $RPM_BUILD_ROOT/var/tomcat/bin/*.bat
rm $RPM_BUILD_ROOT/var/tomcat/bin/tomcat.exe

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/useradd -r -d /var/tomcat -s /bin/bash \
    -c "Tomcat" -u 90 tomcat > /dev/null 2>&1 || :

%post
if [ $1 = 1 ]; then
    /sbin/chkconfig --add tomcat
fi

%preun
if [ $1 = 0 ]; then
    /sbin/service tomcat stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del tomcat
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service tomcat stop >/dev/null 2>&1 || :
fi
if [ $1 = 0 ] ; then
    userdel tomcat >/dev/null 2>&1 || :
    groupdel tomcat >/dev/null 2>&1 || : 
fi

%files
                         %doc    jakarta-tomcat-4.1.30-LE-jdk14/LICENSE
                         %doc    jakarta-tomcat-4.1.30-LE-jdk14/*.txt
                                 /etc/httpd/conf.d/jk.conf-sample
                                 /etc/httpd/conf.d/jk2.conf-sample
                         %config /etc/httpd/conf/workers.properties
                         %config /etc/httpd/conf/workers2.properties
                                 /etc/rc.d/init.d/tomcat
                                 /etc/logrotate.d/tomcat
                                 /usr/lib/httpd/modules/mod_jk.so
                                 /usr/lib/httpd/modules/mod_jk2.so
                         %dir    /var/tomcat
                                 /var/tomcat/bin
                                 /var/tomcat/common
%attr(-, tomcat, tomcat) %config /var/tomcat/conf
%attr(-, tomcat, tomcat)         /var/tomcat/logs
                                 /var/tomcat/server
                                 /var/tomcat/shared
%attr(-, tomcat, tomcat)         /var/tomcat/temp
%attr(-, tomcat, tomcat)         /var/tomcat/webapps
%attr(-, tomcat, tomcat)         /var/tomcat/work

%changelog
* Wed Jul  7 2004 Gregory E. Bailey <gbailey@lxpro.com>
- Modified for j2sdk1.4.2_05

* Wed Jun 30 2004 Gregory E. Bailey <gbailey@lxpro.com>
- Modified for Tomcat 4.1.30 (Fedora Core 1)

* Tue Aug 19 2003 Gregory E. Bailey <gbailey@lxpro.com>
- Modified for Tomcat 4.1.27
- Include hotfix #22096
- Updated to use Sun J2SE 1.4.2
- Build both JK and JK2 connectors

* Wed Feb 13 2002 Gregory E. Bailey <gbailey@lxpro.com>
- Modified for Tomcat 4.0.2
- Removed /usr/bin/jspc and /usr/bin/tomcat

* Fri Nov 16 2001 Gregory E. Bailey <gbailey@lxpro.com>
- Initial release
